package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.Date;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.VendaPacoteDAO;
import com.rjconsultores.ventaboletos.entidad.VendaPacote;

@Repository("vendaPacoteDAO")
public class VendaPacoteHibernateDAO extends GenericHibernateDAO<VendaPacote, Long> implements VendaPacoteDAO {
	
    @Autowired
    public VendaPacoteHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
	@SuppressWarnings("unchecked")
	public List<VendaPacote> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        return c.list();
	}

	@Override
	@Transactional
	public VendaPacote suscribir(VendaPacote entidad) {
		entidad.setFecmodif(new Date());
		return super.suscribir(entidad);
	}

	@Override
	@Transactional
	public VendaPacote actualizacion(VendaPacote entidad) {
		entidad.setFecmodif(new Date());
		return super.actualizacion(entidad);
	}

}
